#include <iostream>
#define MaxN 100

using namespace std;

int main()
{
    int n, m, a[MaxN][MaxN];
    cin>>n>>m;
    for(int i=0; i<n; i++)
    {
        for(int j=0; j<m; j++)
        {
            cin>>a[i][j];
        }
    }
    if(n*m<6)
        cout<<0<<endl;
    else if(n*m<16)
    cout<<1<<endl;
    else cout<<min(m,n)<<endl;
}